import wfdb #WaveForm-Database package. A library of tools for reading, writing, and processing WFDB signals and annotations.
import pandas as pd
import glob

def mit_patientwise_anno_wfdb_to_csv(wfdb_data_path, output_path, tmp_path):
    
    dat_files=glob.glob1(wfdb_data_path,'*.atr') #Get list of all .atr files in the current folder
    df=pd.DataFrame(data=dat_files)
    # print(df)
    # input("X")
    df.to_csv(tmp_path+"files_list.csv",index=False,header=None) #Write the list to a CSV file
    files=pd.read_csv(tmp_path+"files_list.csv",header=None)
    
    for i in range(1,len(files)+1):
        recordname=str(files.iloc[[i-1]])
        # print(recordname)
        recordname_new=recordname[-7:-4] #Extracting just the filename part (will differ from database to database)
        # print(recordname_new)
        # input("x")
        recordname_new = wfdb_data_path + recordname_new
        # print(recordname_new)
        # input("x")
        record = wfdb.rdann(recordname_new,'atr') # rdann() returns the annotation object

        df = pd.DataFrame(columns = ['Sample', "#"])
        df['Sample'] = record.sample
        df["#"] = record.symbol
        df.insert(0, "Dummy", 0)
        
        path= output_path + recordname[-7:-4] + "annotations.csv"
        # print(path)
        # input("x")
        # np.savetxt(path,df,delimiter=",") #Writing the CSV for each record
        df.to_csv(path,index=False)
        print("Files done: %s/%s"% (i,len(files)))
    
    print("\nAll files done!")	
    
