import wfdb #WaveForm-Database package. A library of tools for reading, writing, and processing WFDB signals and annotations.
import pandas as pd
import numpy as np
import glob

def mit_patientwise_wfdb_to_csv(wfdb_data_path, output_path, tmp_path):
    
    dat_files=glob.glob1(wfdb_data_path,'*.dat') #Get list of all .dat files in the current folder
    df=pd.DataFrame(data=dat_files)
    # print(df)
    # input("X")
    df.to_csv(tmp_path+"files_list.csv",index=False,header=None) #Write the list to a CSV file
    files=pd.read_csv(tmp_path+"files_list.csv",header=None)
    
    for i in range(1,len(files)+1):
        recordname=str(files.iloc[[i-1]])
        # print(recordname)
        recordname_new=recordname[-7:-4] #Extracting just the filename part (will differ from database to database)
        # print(recordname_new)
        # input("x")
        recordname_new = wfdb_data_path + recordname_new
        # print(recordname_new)
        # input("x")
        record = wfdb.rdsamp(recordname_new) # rdsamp() returns the signal as a numpy array  
        # print(record)
        # input("x")
        record = np.asarray(record[0])
        # if i ==19:
        #     print(recordname)
        #     print(record[0:25])
        #     input("X")
        #print(record[:-1,:])
        #input("x")
        path=output_path + recordname[-7:-4] + ".csv"
        # print(path)
        # input("x")
        np.savetxt(path,record,delimiter=",") #Writing the CSV for each record
        print("Files done: %s/%s"% (i,len(files)))
    
    print("\nAll files done!")	
    
