import pandas as pd
import os
import glob
import numpy as np

def count_ecg_samples_per_file(data_path):
    #==== Create a csv file containing list of all the subject-wise csv files in the dataset folder ==============##
    data_files=glob.glob1(data_path,'*.csv') #Get list of all .csv files in the current folder
    df=pd.DataFrame(data=data_files)
    df.columns = ['Filename']
    df.to_csv("data_files_list.csv",index=False) #Write the list to a CSV file
    #=============================================================================================================##
    
    # ##============= Create a list of all the csv files in the dataset folder ======================================##
    ## Not used "header=none" to skip first row.
    files_list=pd.read_csv("data_files_list.csv")
    df_size = pd.DataFrame(columns=['# of samples'])
    for i in range(files_list.shape[0]):
        filename = files_list.iloc[i,0]
        filepath = data_path + filename
        if filename != "files_list.csv" and filename != "data_files_list.csv":
            # # If not used "header=none", it skips first row.
            df = pd.read_csv(filepath,header=None)
            # print(df)
            # input("X")
            df_size.loc[i] = df.shape[0]
            print("Filename: ", filename)
            print("No of ECG samples: ",df.shape[0])
            print("---------------------------------------------------------------------")
    # ##=============================================================================================================##

# data_path = "D:/TBCAS_Data_Gen_from_Scratch_30_Dec/2 ECG data MIT/"
# data_path = "D:/TBCAS_Data_Gen_from_Scratch_30_Dec/Kaggle dataset/"
count_ecg_samples_per_file(data_path)