import pandas as pd
import os
import glob
from collections import Counter
import numpy as np

import sys
# np.set_printoptions(threshold=sys.maxsize)
# pd.set_option('display.max_colwidth', None)

def count_expected_beats_per_class(csv_path,script_path,ecg_params_dict):
    
    csv_files_list = pd.read_csv(script_path+"anno_csv_files_list.csv")
    
    overall_beat_labels = pd.DataFrame()
     
    for i in range(csv_files_list.shape[0]):
        print("File under progress: ",csv_files_list.iloc[i,0])
        csv_filepath = csv_path + csv_files_list.iloc[i,0]
        df_csv = pd.read_csv(csv_filepath)
        # print(df_csv[df_csv.eq().any(1)])
        # print(df_csv)
        # input("x")
        lower_limit = ecg_params_dict["ecg_samples_before_peak"] + 1
        upper_limit = ecg_params_dict["ecg_max_index"] - ecg_params_dict["ecg_samples_after_peak"] + 1
        df_new = df_csv.loc[(df_csv['Sample'] > lower_limit) & (df_csv['Sample'] < upper_limit)]
        # df_new = df_new.loc[:,'Sample':"#"]
        df_new = df_new["#"]
        # df_new = df_new.reset_index(drop=True)
        if i == 0:
            overall_beat_labels = df_new            
        else:
            overall_beat_labels = pd.concat([overall_beat_labels, df_new],axis=0)
            # print(overall_beat_labels.shape)
            # input("X")
    
    # overall_beat_labels.to_csv("garbage.csv",index=False, header=None)
    # overall_beat_labels = pd.read_csv("garbage.csv")
    # print(overall_beat_labels)
    # input("X")
    y = overall_beat_labels.to_numpy()
    # print(y)
    # input("X")
    freq = Counter(y)  
    val, counts= np.unique(y, return_counts=True)
    print(val)
    print(counts)
    # input("X")
    valid_keys = ['N', '/', 'L', 'R', 'e', 'j', 'A', 'a', 'J', 'S', 'E', 'F', 'V', 'f', 'Q']
    print("Classes distribution: ")
    total_beats = 0
    for (key, value) in sorted(freq.items()): 
        if key in valid_keys:
            print(key, " -> ", value)
            total_beats = total_beats + value
    # print("Total Beats = ", sum(freq.values()))
    print("Total beats = ", total_beats)
    print("------------------------------------------------------------------")
        
        
ecg_params_dict ={}
ecg_params_dict["ecg_max_index"] = 649999
ecg_params_dict["ecg_samples_before_peak"] = 90
ecg_params_dict["ecg_samples_after_peak"] = 160
script_path = os.getcwd() + "/"
csv_path = "D:/TBCAS_Data_Gen_from_Scratch_30_Dec/1 Annotations/csv_vsersions/"
count_expected_beats_per_class(csv_path,script_path,ecg_params_dict)